<template>
  <div class="fr-container fr-p-5w">
    <TheHeader
      title="Créer un·e bénéficiaire"
      :back-link="Routes.Beneficiaries"
    />
    <div class="fr-grid-row fr-grid-row--gutters">
      <div class="fr-col-12">
        <main
          ref="formContainer"
          class="main-container fr-p-5w"
        >
          <AtomLoader
            v-if="pending"
            class="fr-mx-auto"
          />
          <AtomAlert
            v-else-if="error"
            :alert-type="AlertType.Error"
            message="La liste des agents n'a pas pu être chargée."
          />
          <BeneficiaryForm
            v-else-if="agents.length"
            :agents="agents"
            :is-submitting="isSubmitting"
            @save-beneficiary="onSaveBeneficiary"
          />
        </main>
      </div>
    </div>
  </div>
</template>

<script setup>
  import { AlertType } from '~~/utils/constants/alert'
  import { errorResponseMessage } from '~~/utils/errorResponse'
  import { getRandomId } from '~~/utils/random'
  import { Routes } from '~/utils/routing/routes'

  const { $loadAgents, $createItem, $snackbar } = useNuxtApp()

  const isSubmitting = ref(false)
  const formContainer = ref(null)

  const {
    data: agents,
    pending,
    error
  } = useLazyAsyncData(getRandomId('agents'), $loadAgents, {
    server: false
  })

  async function onSaveBeneficiary(beneficiary) {
    isSubmitting.value = true

    if (beneficiary.relatives) {
      beneficiary.relatives.forEach(r => {
        delete r.id
      })
    }

    try {
      const res = await $createItem('beneficiary', beneficiary)

      if (res.status === 200) {
        return navigateTo(Routes.Beneficiary(res.data.data.id))
      }
      throw new Error(errorResponseMessage(res))
    } catch {
      $snackbar.error('La création du bénéficiaire a échoué.', () =>
        formContainer.value?.querySelector('input')?.focus()
      )
    }
    isSubmitting.value = false
  }
</script>
